main()
{
	//maps\mp\mp_bookstore_fx::main();
	//maps\createart\mp_bookstore_art::main();
	maps\mp\_load::main();	
	
	maps\mp\_compass::setupMiniMap("compass_map_mp_bookstore");

	//setExpFog(500, 2200, 0.81, 0.75, 0.63, 0);
	//VisionSetNaked( "mp_bookstore" );
	ambientPlay("ambient_bookstore_ext");

	game["allies"] = "sas";
	game["axis"] = "opfor";
	game["attackers"] = "axis";
	game["defenders"] = "allies";
	game["allies_soldiertype"] = "woodland";
	game["axis_soldiertype"] = "woodland";

	setdvar( "r_specularcolorscale", "1" );
	setdvar("r_glowbloomintensity0",".25");
	setdvar("r_glowbloomintensity1",".25");
	setdvar("r_glowskybleedintensity0",".3");
	setdvar("compassmaxrange","1800");

	//fx
	level.fx_rain_skylight = loadfx("weather/rain_dave");

	//rain code
	rain = getentarray("rain","targetname");
	for(i=0;i<rain.size;i++)
	{
		rain[i] thread storming();
	}
	rainwindow = getentarray("rainwindow","targetname");
	for(i=0;i<rainwindow.size;i++)
	{
		rainwindow[i] thread raining();
	}

	//elevator and switch code
	trig_power_switch = getentarray("trig_power_switch","targetname");
	level.power_on = true;
	for(i=0;i<trig_power_switch.size;i++)
	{
		trig_power_switch[i].switchmodel = getent(trig_power_switch[i].target, "targetname");
		trig_power_switch[i].switchmodel notsolid();
		trig_power_switch[i].switchmodel.switchmoving = false;
		trig_power_switch[i].switchmodel.switchup = true;
		trig_power_switch[i].switchmodel.time = 0.5; //how long it takes the switch to swing
		trig_power_switch[i] thread switchswing();
	}

	level.elevator = getent("elevator","targetname");
	level.elevator_floor_top = getent("elevator_floor_top","targetname");
	level.elevator_floor_bottom = getent("elevator_floor_bottom","targetname");
	level.elevator_door_inside_left = getent("elevator_door_inside_left","targetname");
	level.elevator_door_inside_right = getent("elevator_door_inside_right","targetname");
	level.elevator_door_downstairs_left = getent("elevator_door_downstairs_left","targetname");
	level.elevator_door_downstairs_right = getent("elevator_door_downstairs_right","targetname");
	level.elevator_door_upstairs_left = getent("elevator_door_upstairs_left","targetname");
	level.elevator_door_upstairs_right = getent("elevator_door_upstairs_right","targetname");

	level.elevator_button_time = 0.1; //how long it takes the buttons to move
	level.elevator_button_move = 1; //how far the buttons move
	level.elevator_button_inside_in = false;
	level.elevator_button_downstairs_in = false;
	level.elevator_button_upstairs_in = false;
	level.elevator_door_time = 1; //how long it takes the doors to move
	level.elevator_door_move = 25; //how far the doors move
	level.elevator_doors_inside_open = false;
	level.elevator_doors_downstairs_open = false;
	level.elevator_doors_upstairs_open = false;
	level.elevator_time = 4; //total time it takes the elevator to move between floors
	level.elevator_distance = distance(level.elevator_floor_top.origin, level.elevator_floor_bottom.origin);
	level.elevator_interval_move = 1;
	level.elevator_position_min = 0;
	level.elevator_position_max = int(level.elevator_distance/level.elevator_interval_move);
	level.elevator_position = 0;
	level.elevator_interval_time = level.elevator_time/level.elevator_position_max;
	level.elevator_moving = 0; //0 = stay, -1 = down, 1 = up

	level.elevator_trig_crush = getent("trig_elevator_crush","targetname");
	level.elevator_trig_crush_script_model = spawn ("script_model",(0,0,0));
	level.elevator_trig_crush EnableLinkTo();
	level.elevator_trig_crush linkto (level.elevator_trig_crush_script_model);

	level.elevator_trig_doors_upstairs_inner = getent("trig_elevator_doors_upstairs_inner","targetname");
	level thread elevator_doors_upstairs_inner();

	level.elevator_trig_doors_upstairs_outer = getent("trig_elevator_doors_upstairs_outer","targetname");
	level thread elevator_doors_upstairs_outer();

	level.elevator_trig_button_inside = getent("trig_elevator_button_inside","targetname");
	level.elevator_button_inside = getent(level.elevator_trig_button_inside.target, "targetname");
	level.elevator_trig_button_inside EnableLinkTo();
	level.elevator_trig_button_inside linkto (level.elevator);
	level thread elevator_button_inside_pushed_in();

	level.elevator_trig_button_downstairs = getent("trig_elevator_button_downstairs","targetname");
	level.elevator_button_downstairs = getent(level.elevator_trig_button_downstairs.target, "targetname");
	level thread elevator_button_downstairs_pushed_in();

	level.elevator_trig_button_upstairs = getent("trig_elevator_button_upstairs","targetname");
	level.elevator_button_upstairs = getent(level.elevator_trig_button_upstairs.target, "targetname");
	level thread elevator_button_upstairs_pushed_in();

	level.elevator_trig_ceiling = getentarray("trig_elevator_ceiling","targetname");
	for(i=0;i<level.elevator_trig_ceiling.size;i++)
	{
		level.elevator_trig_ceiling[i].ceiling = getent(level.elevator_trig_ceiling[i].target, "targetname");
		level.elevator_trig_ceiling[i].broken = false;
		level.elevator_trig_ceiling[i].ceiling linkto (level.elevator);
		level.elevator_trig_ceiling[i] EnableLinkTo();
		level.elevator_trig_ceiling[i] linkto (level.elevator);
		level.elevator_trig_ceiling[i] thread elevator_ceiling_break();
	}

	//glass code
	fxwindowbreak = loadfx ("props/car_glass_large");
	trigwindowbreak = getentarray("trigwindowbreak","targetname");
	for(i=0;i<trigwindowbreak.size;i++)
	{
		trigwindowbreak[i].windowmodel = getent(trigwindowbreak[i].target, "targetname");
		trigwindowbreak[i] thread windowbreak(i,fxwindowbreak);
	}
	trigwindowindoorbreak = getentarray("trigwindowindoorbreak","targetname");
	for(i=0;i<trigwindowindoorbreak.size;i++)
	{
		trigwindowindoorbreak[i].windowmodel = getent(trigwindowindoorbreak[i].target, "targetname");
		trigwindowindoorbreak[i].doormodel = getent(trigwindowindoorbreak[i].windowmodel.target, "targetname");
		trigwindowindoorbreak[i] EnableLinkTo();
		trigwindowindoorbreak[i] linkto (trigwindowindoorbreak[i].doormodel);
		trigwindowindoorbreak[i].windowmodel linkto (trigwindowindoorbreak[i].doormodel);
		trigwindowindoorbreak[i] thread windowbreak(i,fxwindowbreak);
	}
	trigskylight = getentarray("trigskylight","targetname");
	for(i=0;i<trigskylight.size;i++)
	{
		trigskylight[i].windowmodel = getent(trigskylight[i].target, "targetname");
		trigskylight[i] thread skylightbreak(i,fxwindowbreak);
	}

	//door code
	trigdoorswing = getentarray("trigdoorswing","targetname");
	for(i=0;i<trigdoorswing.size;i++)
	{
		if (trigdoorswing[i].script_noteworthy == "ccw")
		{
		trigdoorswing[i].intswingdirection = 1;
		}
		else
		{
		trigdoorswing[i].intswingdirection = -1;		
		}
		trigdoorswing[i].doormodel = getent(trigdoorswing[i].target, "targetname");
		trigdoorswing[i].doormodel.doormoving = false;
		trigdoorswing[i].doormodel.doorclosed = true;
		trigdoorswing[i].doormodel.time = 0.7; //how long it takes the door to swing
		trigdoorswing[i] thread doorswing();
	}
	doorknob = getentarray("doorknob","targetname");
	for(i=0;i<doorknob.size;i++)
	{
		doorknob[i] notSolid();
		doorknob[i].doormodel = getent(doorknob[i].target, "targetname");
		doorknob[i] linkto (doorknob[i].doormodel);
	}

	//counter code
	trigcounterswing = getentarray("trigcounterswing","targetname");
	for(i=0;i<trigcounterswing.size;i++)
	{
		trigcounterswing[i].doormodel = getent(trigcounterswing[i].target, "targetname");
		trigcounterswing[i].doormodel notsolid();
		trigcounterswing[i].doormodel.doormoving = false;
		trigcounterswing[i].doormodel.doorclosed = true;
		trigcounterswing[i].doormodel.time = 0.25; //how long it takes the door to swing
		trigcounterswing[i] thread counterswing();
	}

	//escalator code
	escalator = getentarray("escalator","targetname");
	for(i=0;i<escalator.size;i++)
	{
		escalator[i].step_max = 13;
		escalator[i].step_place[0] = escalator[i];
		for(j=1;j<escalator[i].step_max;j++)
		{
			escalator[i].step_place[j] = getent(escalator[i].step_place[j-1].target, "targetname");
		}
		escalator[i].step[0] = getent(escalator[i].step_place[escalator[i].step_max-1].target, "targetname");
		for(j=1;j<escalator[i].step_max;j++)
		{
			escalator[i].step[j] = getent(escalator[i].step[j-1].target, "targetname");
		}
		for(j=0;j<escalator[i].step_max;j++)
		{
			escalator[i] thread escalatormove(j);
		}
	}

}

//escalator code
escalatormove(index)
{
	counter = 0;
	while(true)
	{
		while (level.power_on)
		{
			nextstep = index + counter;
			if (nextstep >= self.step_max)
			{
				nextstep = nextstep - self.step_max;
			}
			if (nextstep == 0)
			{
				self.step[index] notsolid();
				self.step[index] hide();
			}
			else
			{
				self.step[index] solid();
				self.step[index] show();				
			}
			self.step[index] moveto(self.step_place[nextstep].origin, 0.5);
			self.step[index] waittill("movedone");
			counter++;
			if (counter >= self.step_max)
			{
				counter = 0;
			}
		}
		wait(0.1);
	}
}


//counter code
counterswing()
{
	while (1)
	{
		self waittill("trigger");
		if(!self.doormodel.doormoving)
		{
			self.doormodel.doormoving = true;
			if(self.doormodel.doorclosed)
			{
				if (self.script_noteworthy == "north")
				{
					self.doormodel rotateroll(-90,self.doormodel.time,self.doormodel.time*0.5,self.doormodel.time*0.5);
				}
				else if (self.script_noteworthy == "south")
				{
					self.doormodel rotateroll(90,self.doormodel.time,self.doormodel.time*0.5,self.doormodel.time*0.5);
				}
				else if (self.script_noteworthy == "west")
				{
					self.doormodel rotatepitch(-90,self.doormodel.time,self.doormodel.time*0.5,self.doormodel.time*0.5);
				}
				else if (self.script_noteworthy == "east")
				{
					self.doormodel rotatepitch(90,self.doormodel.time,self.doormodel.time*0.5,self.doormodel.time*0.5);
				}
				self.doormodel playsound("doormove");
				self.doormodel waittill("rotatedone");
				self.doormodel.doorclosed = false;
		
				//close door again
				wait 4;
				if (self.script_noteworthy == "north")
				{
					self.doormodel rotateroll(90,self.doormodel.time,self.doormodel.time*0.5,self.doormodel.time*0.5);
				}
				else if (self.script_noteworthy == "south")
				{
					self.doormodel rotateroll(-90,self.doormodel.time,self.doormodel.time*0.5,self.doormodel.time*0.5);
				}
				else if (self.script_noteworthy == "west")
				{
					self.doormodel rotatepitch(90,self.doormodel.time,self.doormodel.time*0.5,self.doormodel.time*0.5);
				}
				else if (self.script_noteworthy == "east")
				{
					self.doormodel rotatepitch(-90,self.doormodel.time,self.doormodel.time*0.5,self.doormodel.time*0.5);
				}
				self.doormodel playsound("doormove");
				self.doormodel waittill("rotatedone");
				self.doormodel.doorclosed = true;		
			}
			self.doormodel.doormoving = false;			
		}
	}
}

//door code
doorswing()
{
	while (1)
	{
		self waittill("trigger");
		if(!self.doormodel.doormoving)
		{
			self.doormodel.doormoving = true;
			if(self.doormodel.doorclosed)
			{
				self.doormodel rotateyaw(self.intswingdirection * 90,self.doormodel.time,self.doormodel.time*0.5,self.doormodel.time*0.5);
				self.doormodel playsound("doormove");
				self.doormodel waittill("rotatedone");
				self.doormodel.doorclosed = false;
		
				//close door again
				wait 4;
				self.doormodel rotateyaw(self.intswingdirection * -90,self.doormodel.time,self.doormodel.time*0.5,self.doormodel.time*0.5);
				self.doormodel playsound("doormove");
				self.doormodel waittill("rotatedone");
				self.doormodel.doorclosed = true;		
			}
			self.doormodel.doormoving = false;			
		}
	}
}

//glass code
windowbreak(windownumber,fxwindowbreak)
{
	windowbroken=false;
	while (1)
	{
		self waittill("trigger");
		while(!windowbroken)
		{
			windowbroken=true;
			//self playsound("glass_break");
			PlayFX(fxwindowbreak, self.origin);
			self.windowmodel notSolid();
			self.windowmodel hide();
		}
	}
}
skylightbreak(windownumber,fxwindowbreak)
{
	windowbroken=false;
	while (1)
	{
		self waittill("trigger");
		while(!windowbroken)
		{
			windowbroken=true;
			PlayFX(fxwindowbreak, self.origin);
			self.windowmodel notSolid();
			self.windowmodel hide();
			PlayFx(level.fx_rain_skylight, self.origin - (0, 0, 64));
		}
	}
}

//rain code
storming()
{
	//level._effect["rain"] = loadfx ("weather/rain_mp_farm");
	level._effect["lightning"] = loadfx ("weather/lightning_mp_farm");
	//maps\mp\_fx::loopfx("rain",(self.origin),8);
	maps\mp\_fx::loopfx("lightning",(self.origin),8);
	wait(5);
	while (1)
	{
	self playsound("rainthunder");
	wait(70);
	}
}
raining()
{
	//level._effect["rain"] = loadfx ("weather/rain_dave");
	//maps\mp\_fx::loopfx("rain",(self.origin),8);
	wait(10);
	PlayFx(level.fx_rain_skylight, self.origin - (0, 0, 64));
}

//elevator and switch code
switchswing()
{
	while (1)
	{
		self waittill("trigger");
		if(!self.switchmodel.switchmoving)
		{
			self.switchmodel.switchmoving = true;
			if(self.switchmodel.switchup)
			{
				level.power_on = false;
				self.switchmodel rotateroll(180,self.switchmodel.time,self.switchmodel.time*0.5,self.switchmodel.time*0.5);
				self.switchmodel waittill("rotatedone");
				self.switchmodel.switchup = false;
				level thread elevator_button_inside_move_out();
				level thread elevator_button_downstairs_move_out();
				level thread elevator_button_upstairs_move_out();
				setExpFog(0, 150, 0, 0, 0, 0.0);
			}
			else
			{
				level.power_on = true;
				self.switchmodel rotateroll(-180,self.switchmodel.time,self.switchmodel.time*0.5,self.switchmodel.time*0.5);
				self.switchmodel waittill("rotatedone");
				self.switchmodel.switchup = true;
				if (level.elevator_moving == 1)
				{
					level thread elevator_up();
				}
				else if (level.elevator_moving == -1)
				{
					level thread elevator_down();
				}
				setExpFog(4000, 5000, 0, 0, 0, 0.0);
			}
			self.switchmodel.switchmoving = false;			
		}
	}
}

elevator_ceiling_break()
{
	while (1)
	{
		self waittill("trigger");
		if(!self.broken)
		{
			self playsound("break");
			self.ceiling notsolid();
			self.ceiling hide();
			self.broken = true;
		}
	}
}

elevator_doors_upstairs_inner()
{
	while (1)
	{
		self.elevator_trig_doors_upstairs_inner waittill("trigger");
		if(!self.elevator_doors_upstairs_open)
		{
			self thread elevator_doors_upstairs_move_open();
			wait(2);
			self thread elevator_doors_upstairs_move_closed();
		}
	}
}

elevator_doors_upstairs_outer()
{
	while (1)
	{
		self.elevator_trig_doors_upstairs_outer waittill("trigger");
		if(!self.elevator_doors_upstairs_open && !level.power_on)
		{
			self thread elevator_doors_upstairs_move_open();
			wait(2);
			self thread elevator_doors_upstairs_move_closed();
		}
	}
}

elevator_button_inside_pushed_in()
{
	while (1)
	{
		self.elevator_trig_button_inside waittill("trigger");
		if(!self.elevator_button_inside_in)
		{
			self thread elevator_button_inside_move_in();
			level waittill("elevator_button_inside_move_in_done");
			if(self.elevator_position>self.elevator_position_max)
			{
				if(self.power_on)
				{
					self thread elevator_down();
					level waittill("elevator_down_done");
				}
			}
			else if(self.elevator_position<self.elevator_position_min)
			{
				if(self.power_on)
				{
					self thread elevator_up();
					level waittill("elevator_up_done");
				}
			}
			self thread elevator_button_inside_move_out();
			level waittill("elevator_button_inside_move_out_done");
		}
	}
}

elevator_button_downstairs_pushed_in()
{
	while (1)
	{
		self.elevator_trig_button_downstairs waittill("trigger");
		if(!self.elevator_button_downstairs_in)
		{
			self thread elevator_button_downstairs_move_in();
			level waittill("elevator_button_downstairs_move_in_done");
			if (self.elevator_moving == 1 && self.elevator_button_inside_in)
			{
				level waittill("elevator_button_inside_move_out_done");
				wait(2);
			}
			if(self.power_on)
			{
				self thread elevator_down();
				level waittill("elevator_down_done");
			}
			self thread elevator_button_downstairs_move_out();
			level waittill("elevator_button_downstairs_move_out_done");
		}
	}
}

elevator_button_upstairs_pushed_in()
{
	while (1)
	{
		self.elevator_trig_button_upstairs waittill("trigger");
		if(!self.elevator_button_upstairs_in)
		{
			self thread elevator_button_upstairs_move_in();
			level waittill("elevator_button_upstairs_move_in_done");
			if (self.elevator_moving == -1 && self.elevator_button_inside_in)
			{
				level waittill("elevator_button_inside_move_out_done");
				wait(2);
			}
			if(self.power_on)
			{
				self thread elevator_up();
				level waittill("elevator_up_done");
			}
			self thread elevator_button_upstairs_move_out();
			level waittill("elevator_button_upstairs_move_out_done");
		}
	}
}

elevator_button_inside_move_in()
{
	if(!self.elevator_button_inside_in)
	{
		self.elevator_button_inside movex(self.elevator_button_move,self.elevator_button_time);
		self.elevator_button_inside waittill("movedone");
		self.elevator_button_inside_in = true;
	}
	wait(0.01);
	level notify("elevator_button_inside_move_in_done");
}

elevator_button_downstairs_move_in()
{
	if(!self.elevator_button_downstairs_in)
	{
		self.elevator_button_downstairs movex(-1*self.elevator_button_move,self.elevator_button_time);
		self.elevator_button_downstairs waittill("movedone");
		self.elevator_button_downstairs_in = true;
	}
	wait(0.01);
	level notify("elevator_button_downstairs_move_in_done");
}

elevator_button_upstairs_move_in()
{
	if(!self.elevator_button_upstairs_in)
	{
		self.elevator_button_upstairs movex(-1*self.elevator_button_move,self.elevator_button_time);
		self.elevator_button_upstairs waittill("movedone");
		self.elevator_button_upstairs_in = true;
	}
	wait(0.01);
	level notify("elevator_button_upstairs_move_in_done");
}

elevator_button_inside_move_out()
{
	if(self.elevator_button_inside_in)
	{
		self.elevator_button_inside movex(-1*self.elevator_button_move,self.elevator_button_time);
		self.elevator_button_inside waittill("movedone");
		self.elevator_button_inside_in = false;
	}
	wait(0.01);
	level notify("elevator_button_inside_move_out_done");
}

elevator_button_downstairs_move_out()
{
	if(self.elevator_button_downstairs_in)
	{
		self.elevator_button_downstairs movex(self.elevator_button_move,self.elevator_button_time);
		self.elevator_button_downstairs waittill("movedone");
		self.elevator_button_downstairs_in = false;
	}
	wait(0.01);
	level notify("elevator_button_downstairs_move_out_done");
}

elevator_button_upstairs_move_out()
{
	if(self.elevator_button_upstairs_in)
	{
		self.elevator_button_upstairs movex(self.elevator_button_move,self.elevator_button_time);
		self.elevator_button_upstairs waittill("movedone");
		self.elevator_button_upstairs_in = false;
	}
	wait(0.01);
	level notify("elevator_button_upstairs_move_out_done");
}

elevator_doors_inside_move_open()
{
	if(!self.elevator_doors_inside_open)
	{
		self.elevator_door_inside_left movey(-1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_inside_right movey(1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_inside_left waittill("movedone");
		self.elevator_doors_inside_open = true;
	}
	wait(0.01);
	level notify("elevator_doors_inside_move_open_done");
}

elevator_doors_downstairs_move_open()
{
	if(!self.elevator_doors_downstairs_open)
	{
		self.elevator_door_downstairs_left movey(-1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_downstairs_right movey(1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_downstairs_left waittill("movedone");
		self.elevator_doors_downstairs_open = true;
	}
	wait(0.01);
	level notify("elevator_doors_downstairs_move_open_done");
}

elevator_doors_upstairs_move_open()
{
	if(!self.elevator_doors_upstairs_open)
	{
		self.elevator_door_upstairs_left movey(-1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_upstairs_right movey(1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_upstairs_left waittill("movedone");
		self.elevator_doors_upstairs_open = true;
	}
	wait(0.01);
	level notify("elevator_doors_upstairs_move_open_done");
}

elevator_doors_inside_move_closed()
{
	if(self.elevator_doors_inside_open)
	{
		self.elevator_door_inside_left movey(1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_inside_right movey(-1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_inside_left waittill("movedone");
		self.elevator_doors_inside_open = false;
	}
	wait(0.01);
	level notify("elevator_doors_inside_move_closed_done");
}

elevator_doors_downstairs_move_closed()
{
	if(self.elevator_doors_downstairs_open)
	{
		self.elevator_door_downstairs_left movey(1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_downstairs_right movey(-1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_downstairs_left waittill("movedone");
		self.elevator_doors_downstairs_open = false;
	}
	wait(0.01);
	level notify("elevator_doors_downstairs_move_closed_done");
}

elevator_doors_upstairs_move_closed()
{
	if(self.elevator_doors_upstairs_open)
	{
		self.elevator_door_upstairs_left movey(1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_upstairs_right movey(-1*self.elevator_door_move,self.elevator_door_time,0.5*self.elevator_door_time,0.5*self.elevator_door_time);
		self.elevator_door_upstairs_left waittill("movedone");
		self.elevator_doors_upstairs_open = false;
	}
	wait(0.01);
	level notify("elevator_doors_upstairs_move_closed_done");
}

elevator_up()
{
	if(self.elevator_position<=self.elevator_position_max && self.power_on)
	{
		if(self.elevator_doors_inside_open)
		{
			self thread elevator_doors_downstairs_move_closed();
			self thread elevator_doors_upstairs_move_closed();
			self thread elevator_doors_inside_move_closed();
			level waittill("elevator_doors_inside_move_closed_done");
			self.elevator playsound("elevatormusic");
		}
		else
		{
			self thread elevator_doors_downstairs_move_closed();
			self thread elevator_doors_upstairs_move_closed();
			self thread elevator_doors_inside_move_closed();
			level waittill("elevator_doors_inside_move_closed_done");
		}
		self thread elevator_button_inside_move_in();
		level waittill("elevator_button_inside_move_in_done");
		for(i=self.elevator_position;i<=self.elevator_position_max;i++)
		{
			if(self.power_on)
			{
				self.elevator_moving = 1;
				self.elevator_button_inside linkto(self.elevator);
				self.elevator_door_inside_left linkto(self.elevator);
				self.elevator_door_inside_right linkto(self.elevator);
				self.elevator moveto(self.elevator_floor_bottom.origin+i*(0,0,self.elevator_interval_move),self.elevator_interval_time);
				self.elevator_trig_crush_script_model moveto((0,0,-1),self.elevator_interval_time);
				self.elevator waittill("movedone");
				self.elevator_button_inside unlink();
				self.elevator_door_inside_left unlink();
				self.elevator_door_inside_right unlink();			
				self.elevator_position = self.elevator_position + 1;
			}
		}
		self.elevator_trig_crush_script_model moveto((0,0,0),self.elevator_interval_time);
		self thread elevator_button_upstairs_move_out();
		level waittill("elevator_button_upstairs_move_out_done");
		self thread elevator_button_inside_move_out();
		level waittill("elevator_button_inside_move_out_done");
		if(self.power_on)
		{
			self.elevator playsound("elevatording");
			self thread elevator_doors_upstairs_move_open();
			self thread elevator_doors_inside_move_open();
			level waittill("elevator_doors_inside_move_open_done");
			self.elevator_moving = 0;
		}
	}
	wait(0.01);
	level notify("elevator_up_done");
}

elevator_down()
{
	if(self.elevator_position>=self.elevator_position_min && self.power_on)
	{
		if(self.elevator_doors_inside_open)
		{
			self thread elevator_doors_downstairs_move_closed();
			self thread elevator_doors_upstairs_move_closed();
			self thread elevator_doors_inside_move_closed();
			level waittill("elevator_doors_inside_move_closed_done");
			self.elevator playsound("elevatormusic");
		}
		else
		{
			self thread elevator_doors_downstairs_move_closed();
			self thread elevator_doors_upstairs_move_closed();
			self thread elevator_doors_inside_move_closed();
			level waittill("elevator_doors_inside_move_closed_done");
		}
		self thread elevator_button_inside_move_in();
		level waittill("elevator_button_inside_move_in_done");
		for(i=self.elevator_position;i>=self.elevator_position_min;i--)
		{
			if(self.power_on)
			{
				self.elevator_moving = -1;
				self.elevator_button_inside linkto(self.elevator);
				self.elevator_door_inside_left linkto(self.elevator);
				self.elevator_door_inside_right linkto(self.elevator);
				self.elevator moveto(self.elevator_floor_bottom.origin+i*(0,0,self.elevator_interval_move),self.elevator_interval_time);
				self.elevator waittill("movedone");
				self.elevator_button_inside unlink();
				self.elevator_door_inside_left unlink();
				self.elevator_door_inside_right unlink();			
				self.elevator_position = self.elevator_position - 1;
			}
		}
		self thread elevator_button_downstairs_move_out();
		level waittill("elevator_button_downstairs_move_out_done");
		self thread elevator_button_inside_move_out();
		level waittill("elevator_button_inside_move_out_done");
		if(self.power_on)
		{
			self.elevator playsound("elevatording");
			self thread elevator_doors_downstairs_move_open();
			self thread elevator_doors_inside_move_open();
			level waittill("elevator_doors_inside_move_open_done");
			self.elevator_moving = 0;
		}
	}
	wait(0.01);
	level notify("elevator_down_done");
}